
#ifndef ASS_H
#define ASS_H

#include "signature.h"
#include "mechDistortion.h"
#include "calViolation.h"

configure *g_config;
data *g_data;

double ass_findAvgEqTupleSize(equivalenceClass *eqClass);
double ass_findAvgSenEqTupleSize(equivalenceClass *eqClass, int senIndex);
double ass_findAvgGlobalDistDiff(equivalenceClass *eqClass, int senIndex, signatureGroupGroupGroup *allSig, int ***allSigMapping, int m);
double ass_findAvgGlobalDistDiffSen(equivalenceClass *eqClass, int senIndex, signatureGroupGroupGroup *allSig, int ***allSigMapping, int m);
int ass_isViolateGlobalDistBoundConditionInOneEqTuple(equivalenceTuple *aEqTuple, int senIndex, signatureGroupGroupGroup *allSig, int ***allSigMapping, int m, int noOfTuple);

int ass_isContainSenIndex(equivalenceTuple *aEqTuple, int senIndex);
int ass_isContainSenIndex_considerNewSen(equivalenceTuple *aEqTuple, int senIndex, configure *config);
double ass_findAvgGlobalDistDiffSen_considerNewSen(equivalenceClass *eqClass, int senIndex, signatureGroupGroupGroup *allSig, int ***allSigMapping, int m, configure *config);

void ass_main(configure *config, data *aData, generalizedAllTable *genAllTable);

#endif

