/*         .h         freeware           http://groups.yahoo.com/group/mathc/ */

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :  swap two cols in a matrix                                         */
/*                                                                            */
/* -------------------------------------------------------------------------- */

void swap_c_R(
PmR m,
int     col1,
int     col2)
{
  int    i;
  MAT_TYPE tnumer;

for ( i = 0 ; i < m->rows ; i++)
 {
                        tnumer = *(m->pb+i *m->cols+(col1)  );
  *(m->pb+i *m->cols+(col1)  ) = *(m->pb+i *m->cols+(col2)  );
  *(m->pb+i *m->cols+(col2)  ) = tnumer;
 }
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    : returns a copy of the matrix m in which column is muliply         */
/*         by scalar                                                          */
/* -------------------------------------------------------------------------- */
void smul_c_R(
PmR m,
int coln,
MAT_TYPE f
)
{
 int i;

 for( i=0; i<m->rows; i++)
    (*(m->pb+i *m->cols+coln)) = f * (*(m->pb+i *m->cols+coln));
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    : returns a copy of the matrix m in which column is muliply         */
/*         by scalar                                                          */
/* -------------------------------------------------------------------------- */
void mul_c_R(
PmR m,
int coln,
MAT_TYPE f
)
{
 int i;

 for( i = 0 ; i < m->rows ; i++)
       (*(m->pb+i *m->cols+coln)) = f * (*(m->pb+i *m->cols+coln)) ;
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    : col1 =  col1 + col2                                                */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void c1_pls_c2_mR(
PmR  m,
int      col1,
int      col2
)
{
   int   i;
MAT_TYPE fr1;
MAT_TYPE fr2;

 for ( i=0 ; i<m->rows ; i++ )
    {
     fr1  = *(m->pb+i *m->cols+(col1)  );
     fr2  = *(m->pb+i *m->cols+(col2)  );
     fr2 +=  (fr1);

     *(m->pb+i *m->cols+(col1)  ) = fr2;
    }
}
