/*         .h         freeware           http://groups.yahoo.com/group/mathc/ */

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void p_norm_mR(
PmR mu,
char c
)
{
MAT_TYPE f;
int i;

//MAT_TYPE pbT[MXR][MXC]; 
//mR mT ={MXR,MXC,&pbT[0][0]};
mR mT;

    mT.rows = 1;          mT.cols = mu->cols;

	mT.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mT.rows*mT.cols);

for(i = 0; i < ((mu->cols) - 1) ; i++)
   {
    copy_r_R(mu,i,&mT, 0);
    f = innerprod_R(&mT,&mT);
    printf("  ||%c%d|| = %+4.3f;",c,i+1,f);
    printf("\n");
   }

free(mT.pb);
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void p_innerprod_mR(
PmR mX,
char c
)
{
MAT_TYPE f;
int i;
int j;

//MAT_TYPE pbvT[MXR][MXC];
//mR mvT ={MXR,MXC,&pbvT[0][0]};
//MAT_TYPE pvnT[MXR][MXC];
//mR mvnT={MXR,MXC,&pvnT[0][0]};

mR mvT;
mR mvnT;

   mvT.rows = 1;          mvT.cols = mX->cols;
  mvnT.rows = 1;         mvnT.cols = mX->cols;

  mvT.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mvT.rows*mvT.cols);
  mvnT.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mvnT.rows*mvnT.cols);

for(i = 0; i < ((mX->cols) - 1) ; i++)
   {
   for(j = 1; j < (mX->cols) ; j++)
     {
      copy_r_R(mX,i,&mvT, 0);
      copy_r_R(mX,j,&mvnT,0);

      f = innerprod_R(&mvT,&mvnT);
      if(!(i==j || i>j))
        {
         printf(" %c%d.%c%d = %+4.3f;",
                   c,i+1,c,j+1,f);
        }
     }
   printf("\n");
   }

  free(mvT.pb);
  free(mvnT.pb);
}


