/*        .h         freeware           http://groups.yahoo.com/group/mathc/ */

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
MAT_TYPE det_mOR(
PmR  mA
)
{
FILE *fp;
MAT_TYPE det;
   int i;
   int j;

mR mdet ={1,1,init_mR(1,1)};

 fp = fopen("data.m","w");
 fprintf(fp," a=[");
 for (i=0 ; i<mA->rows ; i++)
  {
   for (j=0 ; j<mA->cols ; ++j)
    {
     fprintf(fp," %+1.5f",*(mA->pb+i *mA->cols+j   ));
      if(j<(mA->cols-1))fprintf(fp,",");
     }
   if((i+1)<mA->rows) fprintf(fp,";\n");
   else               fprintf(fp,"];\n\n");
  }

  fprintf(fp,"      mdet  = det (a); \n\n");
  fprintf(fp,"ow_mr(mdet,\"adet.dat\");\n");

  fclose(fp);

  printf("                                                         Octave -> data RETURN"); 
  //getchar();

  read_mR(&mdet,"adet.dat");
  det = (*(mdet.pb+0 *mdet.cols+0));

  free(mdet.pb);

  return(det);
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void inverse_mOR(
PmR  mA,
PmR  minvA
)
{
FILE *fp;
 int i;
 int j;

 fp = fopen("data.m","w");

 fprintf(fp," a=[");

 for (i=0 ; i<mA->rows ; i++)
  {
   for (j=0 ; j<mA->cols ; ++j)
    {
     fprintf(fp," %+1.5f",*(mA->pb+i *mA->cols+j   ));
      if(j<(mA->cols-1))fprintf(fp,",");
     }


   if((i+1)<mA->rows) fprintf(fp,";\n");
   else               fprintf(fp,"];\n\n");
  }

  fprintf(fp,"inva=inverse(a);          \n\n");
  fprintf(fp,"ow_mr(inva,\"inva.dat\");\n");

  fclose(fp);

  printf("                                                         Octave -> data RETURN"); 
  //getchar();

  read_mR(minvA,"inva.dat");
}


/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void pinv_mOR(
PmR  mA,
PmR  mpinvA
)
{
FILE *fp;
 int i;
 int j;

 fp = fopen("data.m","w");

 fprintf(fp," a=[");

 for (i=0 ; i<mA->rows ; i++)
  {
   for (j=0 ; j<mA->cols ; ++j)
    {
     fprintf(fp," %+1.5f",*(mA->pb+i *mA->cols+j   ));
      if(j<(mA->cols-1))fprintf(fp,",");
     }


   if((i+1)<mA->rows) fprintf(fp,";\n");
   else               fprintf(fp,"];\n\n");
  }

  fprintf(fp,"pinvA=pinv(a);        \n\n");
  fprintf(fp,"ow_mr(pinvA,\"apinva.dat\");\n");

  fclose(fp);

  printf("                                                         Octave -> data RETURN");
  //getchar();

  read_mR(mpinvA,"apinva.dat");
}


/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void diag_sin_mOR(
PmR  mA,
PmR  msinA
)
{
FILE *fp;
 int i;
 int j;

 fp = fopen("data.m","w");
 fprintf(fp," a=[");
 for (i=0 ; i<mA->rows ; i++)
  {
   for (j=0 ; j<mA->cols ; ++j)
    {
     fprintf(fp," %+1.5f",*(mA->pb+i *mA->cols+j   ));
      if(j<(mA->cols-1))fprintf(fp,",");
     }
   if((i+1)<mA->rows) fprintf(fp,";\n");
   else               fprintf(fp,"];\n\n");
  }

  fprintf(fp,"odiag_sin_mr(a,\"asina.dat\");\n");

  fclose(fp);

  printf("                                                         Octave -> data RETURN"); 
  //getchar();

  read_mR(msinA,"asina.dat");
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void diag_cos_mOR(
PmR  mA,
PmR  mcosA
)
{
FILE *fp;
 int i;
 int j;

 fp = fopen("data.m","w");
 fprintf(fp," a=[");
 for (i=0 ; i<mA->rows ; i++)
  {
   for (j=0 ; j<mA->cols ; ++j)
    {
     fprintf(fp," %+1.5f",*(mA->pb+i *mA->cols+j   ));
      if(j<(mA->cols-1))fprintf(fp,",");
     }
   if((i+1)<mA->rows) fprintf(fp,";\n");
   else               fprintf(fp,"];\n\n");
  }

  fprintf(fp,"odiag_cos_mr(a,\"acosa.dat\");\n");

  fclose(fp);

  printf("                                                         Octave -> data RETURN"); 
  //getchar();

  read_mR(mcosA,"acosa.dat");
}


/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void diag_sinh_mOR(
PmR  mA,
PmR  msinhA
)
{
FILE *fp;
 int i;
 int j;

 fp = fopen("data.m","w");
 fprintf(fp," a=[");
 for (i=0 ; i<mA->rows ; i++)
  {
   for (j=0 ; j<mA->cols ; j++)
    {
     fprintf(fp," %+1.5f ",*(mA->pb+i *mA->cols+j   ) );
      if(j<(mA->cols-1))fprintf(fp,",");
     }
   if((i+1)<mA->rows) fprintf(fp,";\n");
   else               fprintf(fp,"];\n\n");
  }

  fprintf(fp,"odiag_sinh_mr(a,\"asinha.dat\");\n");

  fclose(fp);

  printf("                                                         Octave -> data RETURN"); 
  //getchar();

  read_mR(msinhA,"asinha.dat");
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void diag_cosh_mOR(
PmR  mA,
PmR  mcoshA
)
{
FILE *fp;
 int i;
 int j;

 fp = fopen("data.m","w");
 fprintf(fp," a=[");
 for (i=0 ; i<mA->rows ; i++)
  {
   for (j=0 ; j<mA->cols ; j++)
    {
     fprintf(fp," %+1.5f ", *(mA->pb+i *mA->cols+j   ) );
     if(j<(mA->cols-1))fprintf(fp,",");
     }
   if((i+1)<mA->rows) fprintf(fp,";\n");
   else               fprintf(fp,"];\n\n");
  }

  fprintf(fp,"odiag_cosh_mr(a,\"acosha.dat\");\n");

  fclose(fp);

  printf("                                                         Octave -> data RETURN"); 
  //getchar();

  read_mR(mcoshA,"acosha.dat");
}


