/*         .h         freeware           http://groups.yahoo.com/group/mathc/ */

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_commuteh_mOR(
PmR sinA,
PmR cosA,
int i
)
{
int        n;
MAT_TYPE det;

//MAT_TYPE pbA       [MXR][MXC];
//mR A        ={MXR,MXC,&pbA       [0][0]};
//MAT_TYPE pbP       [MXR][MXC];
//mR P        ={MXR,MXC,&pbP       [0][0]};
//MAT_TYPE pbInvP    [MXR][MXC];
//mR InvP     ={MXR,MXC,&pbInvP    [0][0]};
//MAT_TYPE pbD       [MXR][MXC];
//mR D        ={MXR,MXC,&pbD       [0][0]};
//MAT_TYPE pbsinD    [MXR][MXC];
//mR sinD     ={MXR,MXC,&pbsinD    [0][0]};
//MAT_TYPE pbcosD    [MXR][MXC];
//mR cosD     ={MXR,MXC,&pbcosD    [0][0]};
//MAT_TYPE pbT       [MXR][MXC];
//mR T        ={MXR,MXC,&pbT       [0][0]};

mR A;
mR P;
mR InvP;
mR D;
mR sinD;
mR cosD;
mR T;

                                 n = sinA->rows;

                     A.rows= n;                     A.cols= n;
                     P.rows= n;                     P.cols= n;
                  InvP.rows= n;                  InvP.cols= n;
                     D.rows= n;                     D.cols= n;
                  sinD.rows= n;                  sinD.cols= n;
                  cosD.rows= n;                  cosD.cols= n;
                     T.rows= n;                     T.cols= n;

					 A.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*A.rows*A.cols);
					 P.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*P.rows*P.cols);
					 InvP.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*InvP.rows*InvP.cols);
					 D.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*D.rows*D.cols);
					 sinD.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*sinD.rows*sinD.cols);
					 cosD.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*cosD.rows*cosD.cols);
					 T.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*T.rows*T.cols);
/*-------------------------------- PROGRAM ---------------------------------- */
  do
  {
           rnd_mR(&P,i);
        det = det_R(&P);
  }while( (!det));

  rnd_diag_mR(&D,i);
  inverse_mR(&P,&InvP);
  mul_mR(&P, &D,    &T);
  mul_mR(&T, &InvP, &A);
  zeros_mR(&cosD);
  zeros_mR(&sinD);

  mul_mR(&A,&P,&T);           /* invP A P = D : (eigenvalues on the diagonal) */
  mul_mR(&InvP,&T,&D);
  diag_cosh_mOR(&D,&cosD);    /*cosh(D) : (eigenvalues on the diagonal)       */
  mul_mR(&P,&cosD,&T);
  mul_mR(&T,&InvP,cosA);      /* P cosh(D) invP = cosh(A)                     */

  diag_sinh_mOR(&D,&sinD);    /* sinh(D) : (eigenvalues on the diagonal)      */
  mul_mR(&P,&sinD,&T);        /* P sinh(D) invP = sinh(A)                     */
  mul_mR(&T,&InvP,sinA);
}


/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_commute_mOR(
PmR cosA,
PmR sinA,
int i
)
{
int      n;
MAT_TYPE det;

//MAT_TYPE pbA       [MXR][MXC];
//mR A        ={MXR,MXC,&pbA       [0][0]};
//MAT_TYPE pbP       [MXR][MXC];
//mR P        ={MXR,MXC,&pbP       [0][0]};
//MAT_TYPE pbInvP    [MXR][MXC];
//mR InvP     ={MXR,MXC,&pbInvP    [0][0]};
//MAT_TYPE pbD       [MXR][MXC];
//mR D        ={MXR,MXC,&pbD       [0][0]};
//MAT_TYPE pbsinD    [MXR][MXC];
//mR sinD     ={MXR,MXC,&pbsinD    [0][0]};
//MAT_TYPE pbcosD    [MXR][MXC];
//mR cosD     ={MXR,MXC,&pbcosD    [0][0]};
//MAT_TYPE pbT       [MXR][MXC];
//mR T        ={MXR,MXC,&pbT       [0][0]};

mR A;
mR P;
mR InvP;
mR D;
mR sinD;
mR cosD;
mR T;



                                 n = sinA->rows;

                     A.rows= n;                     A.cols= n;
                     P.rows= n;                     P.cols= n;
                  InvP.rows= n;                  InvP.cols= n;
                     D.rows= n;                     D.cols= n;
                  sinD.rows= n;                  sinD.cols= n;
                  cosD.rows= n;                  cosD.cols= n;
                     T.rows= n;                     T.cols= n;

					 A.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*A.rows*A.cols);
					 P.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*P.rows*P.cols);
					 InvP.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*InvP.rows*InvP.cols);
					 D.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*D.rows*D.cols);
					 sinD.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*sinD.rows*sinD.cols);
					 cosD.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*cosD.rows*cosD.cols);
					 T.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*T.rows*T.cols);

/*-------------------------------- PROGRAM ---------------------------------- */
  do
  {
           rnd_mR(&P,i);
        det = det_R(&P);
  }while( (!det));

  rnd_diag_mR(&D,i);
  inverse_mR(&P,&InvP);
  mul_mR(&P, &D,    &T);
  mul_mR(&T, &InvP, &A);
  zeros_mR(&cosD);
  zeros_mR(&sinD);

  mul_mR(&A,&P,&T);          /* invP A P = D : (eigenvalues on the diagonal) */
  mul_mR(&InvP,&T,&D);
  diag_cos_mOR(&D,&cosD); /*   cos(D) : (eigenvalues on the diagonal)     */
  mul_mR(&P,&cosD,&T);
  mul_mR(&T,&InvP,cosA);    /*    P cos(D) invP = cos(A)                    */

  diag_sin_mOR(&D,&sinD); /*   sin(D) : (eigenvalues on the diagonal)     */
  mul_mR(&P,&sinD,&T);
  mul_mR(&T,&InvP,sinA);    /*    P sin(D) invP = sin(A)                    */

					free(A.pb);
					 free(P.pb);
					 free(InvP.pb);
					 free(D.pb);
					 free(sinD.pb);
					 free(cosD.pb);
					 free(T.pb);
}

