/* yrvlc.h           freeware           http://groups.yahoo.com/group/mathc/  */


/* ------------------------------------- FUNCTION --------------------------  */
/* Do    : Rand Linear Combinaison of Two Vector in Rn  with integer coeff.   */
/*                                                                            */
/* see   :                                                                    */
/* -------------------------------------------------------------------------- */
void rnd_LC_2v_Rn_R(
PmR mA)
{
MAT_TYPE s;
     int n;

//MAT_TYPE pbc  [MXR][MXC];
//mR mc    ={MXR,MXC,&pbc   [0][0]};
//MAT_TYPE pbsc1[MXR][MXC];
//mR msc1  ={MXR,MXC,&pbsc1 [0][0]};
//MAT_TYPE pbsc2[MXR][MXC];
//mR msc2  ={MXR,MXC,&pbsc2 [0][0]};
//MAT_TYPE pbc3 [MXR][MXC];
//mR mc3   ={MXR,MXC,&pbc3  [0][0]};

mR mc;
mR msc1;
mR msc2;
mR mc3;

           n = mA->rows;

     mc.rows=n;      mc.cols= 1;
   msc1.rows=n;    msc1.cols= 1;
   msc2.rows=n;    msc2.cols= 1;
    mc3.rows=n;     mc3.cols= 1;

	mc.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mc.rows*mc.cols);
	msc1.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*msc1.rows*msc1.cols);
	msc2.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*msc2.rows*msc2.cols);
	mc3.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mc3.rows*mc3.cols);
/*-------------------------------- PROGRAM ---------------------------------- */
   zeros_mR(mA);

   rnd_mR(&mc,6);copy_c_R(&mc,0,mA,0);s =  (MAT_TYPE) rnd_I(9);smul_mR(s,&mc,&msc1);
   rnd_mR(&mc,6);copy_c_R(&mc,0,mA,1);s =  (MAT_TYPE) rnd_I(9);smul_mR(s,&mc,&msc2);

   add_mR(&msc1,&msc2,&mc3);
   copy_c_R(&mc3, 0, mA,(mA->cols)-1);


   	free(mc.pb);
	free(msc1.pb);
	free(msc2.pb);
	free(mc3.pb);
}


/* ------------------------------------- FUNCTION --------------------------  */
/* Do    : Rand Linear Combinaison of Two Vector in Rn  with integer coeff.   */
/*                                                                            */
/* see   :                                                                    */
/* -------------------------------------------------------------------------- */
void rnd_LC_3v_Rn_R(
PmR mA)
{
MAT_TYPE s;
     int n;

//MAT_TYPE pbc  [MXR][MXC];
//mR mc    ={MXR,MXC,&pbc   [0][0]};
//MAT_TYPE pbsc1[MXR][MXC];
//mR msc1  ={MXR,MXC,&pbsc1 [0][0]};
//MAT_TYPE pbsc2[MXR][MXC];
//mR msc2  ={MXR,MXC,&pbsc2 [0][0]};
//MAT_TYPE pbsc3[MXR][MXC];
//mR msc3  ={MXR,MXC,&pbsc3 [0][0]};
//MAT_TYPE pbc4 [MXR][MXC];
//mR mc4   ={MXR,MXC,&pbc4  [0][0]};

mR mc;
mR msc1;
mR msc2;
mR msc3;
mR mc4;
           n = mA->rows;

     mc.rows=n;      mc.cols= 1;
   msc1.rows=n;    msc1.cols= 1;
   msc2.rows=n;    msc2.cols= 1;
   msc3.rows=n;    msc3.cols= 1;
    mc4.rows=n;     mc4.cols= 1;

	mc.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mc.rows*mc.cols);
	msc1.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*msc1.rows*msc1.cols);
	msc2.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*msc2.rows*msc2.cols);
	msc3.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*msc3.rows*msc3.cols);
	mc4.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mc4.rows*mc4.cols);
/*-------------------------------- PROGRAM ---------------------------------- */
   zeros_mR(mA);

   rnd_mR(&mc,6);copy_c_R(&mc,0,mA,0);s =  (MAT_TYPE) rnd_I(9);smul_mR(s,&mc,&msc1);
   rnd_mR(&mc,6);copy_c_R(&mc,0,mA,1);s =  (MAT_TYPE) rnd_I(9);smul_mR(s,&mc,&msc2);
   rnd_mR(&mc,6);copy_c_R(&mc,0,mA,2);s =  (MAT_TYPE) rnd_I(9);smul_mR(s,&mc,&msc3);

   add_mR(&msc1,&msc2,&mc);
   add_mR(&mc,  &msc3,&mc4);

   copy_c_R(&mc4,0,mA,((mA->cols))-1);

	free(mc.pb);
	free(msc1.pb);
	free(msc2.pb);
	free(msc3.pb);
	free(mc4.pb);
}


