/* xxconic.h          freeware           http://groups.yahoo.com/group/mathc/  */

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void mofcircle_mR(
PmR mpxy,
PmR mOut)
{
   int i;
   int j;

   i=0;    j=0;
  *(mOut->pb+i *mOut->cols+j    )        = 1;
  for (j=1; j<mOut->cols-1; j++) (*(mOut->pb+i *mOut->cols+j))=0;
  *(mOut->pb+i *mOut->cols+j)=1;

   i=1; j=0;
  *(mOut->pb+i *mOut->cols+j+0) = 0;                 /*a y**2*/
  *(mOut->pb+i *mOut->cols+j+1) = 1;
  for (j=2; j<mOut->cols-1; j++) (*(mOut->pb+i *mOut->cols+j))=0;
  *(mOut->pb+i *mOut->cols+j)=1;

  for (   i=2 ; i<mOut->rows; i++)
   {      j=0;

          *(mOut->pb+i *mOut->cols+j    )        = \
       (MAT_TYPE) pow(*(mpxy->pb+(i-2)  *mpxy->cols        ),2);


            j++;                                                /* y**2 */
          *(mOut->pb+i *mOut->cols+j    )        = \
       (MAT_TYPE) pow(*(mpxy->pb+(i-2)  *mpxy->cols +1      ),2);

            j++;                                                 /* x    */
          *(mOut->pb+i *mOut->cols+j    )        = \
          *(mpxy->pb+(i-2)  *mpxy->cols        );

            j++;                                                 /* y    */
          *(mOut->pb+i *mOut->cols+j    )      = \
          *(mpxy->pb+(i-2)  *mpxy->cols +1      );

            j++;
          *(mOut->pb+i *mOut->cols+j    )      =  1;

            j++;
          *(mOut->pb+i *mOut->cols+j    )      =  0;
    }
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void mofconicA_mR(

PmR mpxy,
PmR mOut)
{
   int i;
   int j;

  i=0;  j=0;
  *(mOut->pb+i *mOut->cols+j) = 1;
  for (j=1; j<mOut->cols-1; j++) *(mOut->pb+i *mOut->cols+j)=0;
  *(mOut->pb+i *mOut->cols+j)=1;

  for (i=1; i<mOut->rows; i++)
   {
      j=0;                                                        /* x**2 */
          *(mOut->pb+i *mOut->cols+j    )        = \
       (MAT_TYPE) pow(*(mpxy->pb+(i-1)  *mpxy->cols        ),2);

            j++;                                                  /* y**2 */
          *(mOut->pb+i *mOut->cols+j    )        = \
       (MAT_TYPE) pow(*(mpxy->pb+(i-1)  *mpxy->cols +1      ),2);

            j++;                                                  /* x    */
          *(mOut->pb+i *mOut->cols+j    )        = \
          *(mpxy->pb+(i-1)  *mpxy->cols        );

            j++;                                                  /* y    */
          *(mOut->pb+i *mOut->cols+j    )        = \
          *(mpxy->pb+(i-1)  *mpxy->cols +1      );

            j++;
          *(mOut->pb+i *mOut->cols+j    )        =  1;

            j++;
          *(mOut->pb+i *mOut->cols+j    )        =  0;
    }
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void mofconicE_mR(
PmR mpxy,
PmR mOut)
{
   int i;
   int j;

  for (   i = 0 ; i < mOut->rows -1  ; i++)
   {      j = 0 ;
                                                                      /* x**2 */
          *(mOut->pb+i *mOut->cols+j    )        = \
       (MAT_TYPE) pow(*(mpxy->pb+(i)  *mpxy->cols        ),2);

            j++;                                                  /* y**2 */
          *(mOut->pb+i *mOut->cols+j    )        = \
       (MAT_TYPE) pow(*(mpxy->pb+(i)  *mpxy->cols +1      ),2);

            j++;                                                  /* x    */
          *(mOut->pb+i *mOut->cols+j    )        = \
          *(mpxy->pb+(i)  *mpxy->cols        );

            j++;                                                 /* y    */
          *(mOut->pb+i *mOut->cols+j    )        = \
          *(mpxy->pb+(i)  *mpxy->cols +1      );

            j++;
          *(mOut->pb+i *mOut->cols+j    )        =  1;

            j++;
          *(mOut->pb+i *mOut->cols+j    )        =  0;
    }


    i = mOut->rows -1;

  for (   j = 0 ; j < mOut->cols - 2    ; j++)  *(mOut->pb+i *mOut->cols+j)= 0;
                                                *(mOut->pb+i *mOut->cols+j)= 1;

  j++;
  *(mOut->pb+i *mOut->cols+j    )        =  1;

}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void conicresultis_mR(
PmR mOut)
{
int i;

    i = 0;
    if((*(mOut->pb+i *mOut->cols+mOut->cols-1)))
    printf("   %+.3f x**2 ",*(mOut->pb+i *mOut->cols+mOut->cols-1));

    i++;
    if((*(mOut->pb+i *mOut->cols+mOut->cols-1)))
    printf("%+.3f y**2 ",*(mOut->pb+i *mOut->cols+mOut->cols-1));

    i++;
    if((*(mOut->pb+i *mOut->cols+mOut->cols-1)))
    printf("%+.3f x ",*(mOut->pb+i *mOut->cols+mOut->cols-1));

    i++;
    if((*(mOut->pb+i *mOut->cols+mOut->cols-1)))
    printf("%+.3f y ",*(mOut->pb+i *mOut->cols+mOut->cols-1));

    i++;
    if((*(mOut->pb+i *mOut->cols+mOut->cols-1)))
    printf("%+.3f ",*(mOut->pb+i *mOut->cols+mOut->cols-1));

    printf(" = 0\n");
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void calculate_circle_mR(
PmR mOut,
MAT_TYPE fx,
MAT_TYPE fy)
{
int i;
MAT_TYPE fT;
MAT_TYPE fT2;

fT2 = 0;

    i = 0;
    fT  =  (MAT_TYPE) ( *(mOut->pb+i *mOut->cols+mOut->cols-1) * pow(fx,2));
    fT2 = (fT2+fT);

    i++;
    fT  =  (MAT_TYPE) ( *(mOut->pb+i *mOut->cols+mOut->cols-1) * pow(fy,2));
    fT2 = (fT2+fT);

    i++;
    fT  = *(mOut->pb+i *mOut->cols+mOut->cols-1) * fx;
    fT2 = (fT2+fT);

    i++;
    fT  = *(mOut->pb+i *mOut->cols+mOut->cols-1) * fy;
    fT2 = (fT2+fT);

    i++;
    fT  = *(mOut->pb+i *mOut->cols+mOut->cols-1);
    fT2 = (fT2+fT);

   printf(" With x = %+.3f and  y = %+.3f ",fx,fy);
   printf("  a x**2 + a y**2 + bx + cy + d = %+.3f \n",fT2);
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void calculate_conic_mR(
PmR mOut,
MAT_TYPE fx,
MAT_TYPE fy)
{
int i;
MAT_TYPE fT;
MAT_TYPE fT2;

fT2 = 0;

    i = 0;
    fT =  (MAT_TYPE) ( *(mOut->pb+i *mOut->cols+mOut->cols-1) *  pow(fx,2));
    fT2 = (fT2+fT);

    i++;
    fT =  (MAT_TYPE) ( *(mOut->pb+i *mOut->cols+mOut->cols-1) *  pow(fy,2));
    fT2 = (fT2+fT);

    i++;
    fT = *(mOut->pb+i *mOut->cols+mOut->cols-1) * fx;
    fT2 = (fT2+fT);

    i++;
    fT = *(mOut->pb+i *mOut->cols+mOut->cols-1) * fy;
    fT2 = (fT2+fT);

    i++;
    fT = *(mOut->pb+i *mOut->cols+mOut->cols-1);
    fT2 = (fT2+fT);

   printf(" With x = %+.5f and  y = %+.5f",fx,fy);
   printf("  a x**2+b y**2+c x+d y+e = %+.5f \n",fT2);
}


/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void gplt_conicresultis_mR(
   char filename[FILENAME],
PmR mOut)
{
FILE *fp;
 int i;

   fp = fopen(filename,"w");

    fprintf(fp,"\n");
    fprintf(fp," f(x,y) = ");

    i = 0;
    if((*(mOut->pb+i *mOut->cols+mOut->cols-1)))
    fprintf(fp,"%+.3f*x**2 ",*(mOut->pb+i *mOut->cols+mOut->cols-1));

    i++;
    if((*(mOut->pb+i *mOut->cols+mOut->cols-1)))
    fprintf(fp,"%+.3f*y**2 ",*(mOut->pb+i *mOut->cols+mOut->cols-1));

    i++;
    if((*(mOut->pb+i *mOut->cols+mOut->cols-1)))
    fprintf(fp,"%+.3f*x ",*(mOut->pb+i *mOut->cols+mOut->cols-1));

    i++;
    if((*(mOut->pb+i *mOut->cols+mOut->cols-1)))
    fprintf(fp,"%+.3f*y ",*(mOut->pb+i *mOut->cols+mOut->cols-1));

    i++;
    if((*(mOut->pb+i *mOut->cols+mOut->cols-1)))
    fprintf(fp,"%+.3f ",*(mOut->pb+i *mOut->cols+mOut->cols-1));

   fprintf(fp,"\n\n");
   fprintf(fp," set contour base\n");
   fprintf(fp," set cntrparam levels discrete 0.0\n");
   fprintf(fp," set nosurface\n");
   fprintf(fp," set term table\n");
   fprintf(fp," set out 'curve.dat'\n");
   fprintf(fp," splot f(x,y)\n");
   fprintf(fp," set term windows\n\n");
   fprintf(fp," plot \"curve.dat\" with lines, \"points\" with points\n");
   fprintf(fp," reset\n");

    fclose(fp);
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void gplt_axis_mR(
   char filename[FILENAME]
)
{
FILE *fp;

   fp = fopen(filename,"w");

fprintf(fp,"#\n");
fprintf(fp,"# Worksheet for gp371w32.exe by xhunga bernard 06000 Nice France\n");
fprintf(fp,"#\n");
fprintf(fp,"set zeroaxis\n");
fprintf(fp,"set data style lines\n");
fprintf(fp,"#\n");
fprintf(fp,"#\n");
fprintf(fp,"#\n");
fprintf(fp,"set xrange [-9:9]\n");
fprintf(fp,"set yrange [-9.5:9.5]\n");
fprintf(fp,"#\n");
fprintf(fp,"#\n");
fprintf(fp,"#\n");
fprintf(fp,"  plot \"u1\", \"v1\"\n");
 
 fclose(fp);
}
/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void gplt_vectcol2d_mR(
   char filename[FILENAME],
PmR mA
)
{
FILE *fp;
  int j;

   fp = fopen(filename,"w");

   for (j=0; j<mA->cols; j++)
     fprintf(fp,"  %+.3f  %+.3f \n",
                 *(mA->pb+0 *mA->cols+j),
                 *(mA->pb+1 *mA->cols+j));

  fclose(fp);
}


/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void gplt_vectrow2d_mR(
   char filename[FILENAME],
PmR mA
)
{
FILE *fp;
  int j;
  int i;

   fp = fopen(filename,"w");

for (i=0; i<mA->rows; i++)
  {
   for (j=0; j<mA->cols; j++)
     fprintf(fp,"  %.3f ", *(mA->pb+i  *mA->cols+j));

     fprintf(fp,"\n");
  }
  fclose(fp);
}



