/* .h                        free ware  http://groups.yahoo.com/group/mathc/  */

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ cofactor_Z(
PmZ mA,
int ci,
int cj)
{
complexZ z;

    z   = minor_Z(mA,ci,cj);
    z.r = pow(-1,(ci+1+cj+1))* z.r;
    z.i = pow(-1,(ci+1+cj+1))* z.i;

  return(z);
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void    cofactor_mZ(
PmZ mA,
PmZ mCofactor)
{
     int i;
     int j;
complexZ z;

  if (mA->rows != mCofactor->rows || mA->cols != mCofactor->cols)
    {
     printf("\n mcofactor() error - matrices different sizes");
     printf("\n Press return to continue");
     getchar();
     exit(1);
    }

 for (i=0 ; i<mA->rows ; i++)
  {
   for (j=0 ; j<mA->cols ; j+=C2)
    {
               z =  cofactor_Z(mA,i, j/C2);

     *(mCofactor->pb+i *mCofactor->cols+j   ) = z.r;
     *(mCofactor->pb+i *mCofactor->cols+j+C1) = z.i;
    }
  }
}


