/* .h                        free ware  http://groups.yahoo.com/group/mathc/  */


/* ------------------------------------- FUNCTION --------------------------  */
/* Do    : On a complexZ.                                                     */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ jfpivot_Z(
PmZ      m,
int      rowpivot,
int      colpivot,
int      colp,
int      rown_mns
)
{
complexZ f;

complexZ fn;
complexZ fn_mns;

complexZ fp;
complexZ fpivot;

  fpivot.r =  (*(m->pb+rowpivot  *m->cols+colpivot*C2   ));
  fpivot.i =  (*(m->pb+rowpivot  *m->cols+colpivot*C2+C1));

      fp.r =  (*(m->pb+rowpivot  *m->cols+colp*C2   ));
      fp.i =  (*(m->pb+rowpivot  *m->cols+colp*C2+C1));

   fn_mns.r = -(*(m->pb+rown_mns *m->cols+colpivot*C2   ));
   fn_mns.i = -(*(m->pb+rown_mns *m->cols+colpivot*C2+C1));

      fn.r =  (*(m->pb+rown_mns  *m->cols+colp*C2   ));
      fn.i =  (*(m->pb+rown_mns  *m->cols+colp*C2+C1));


if(colpivot != colp)
{
      f = add_Z( mul_Z(fpivot,fn), mul_Z(fp,fn_mns));
}

if(colpivot == colp)
{
 (*(m->pb+rown_mns *m->cols+colpivot*C2   )) = 0;
 (*(m->pb+rown_mns *m->cols+colpivot*C2+C1)) = 0;

 f = add_Z( mul_Z(fpivot,fn), mul_Z(fp,fn_mns));
}

 return(f);
}


/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :  On a row.                                                         */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void jrpivot_mZ(
PmZ  m,
int      rowpivot,
int      colpivot,
int      rown_mns
)
{
     int colp;
complexZ f;

    if( (*(m->pb+rowpivot  *m->cols+colpivot*C2   ))
                       ||
        (*(m->pb+rowpivot  *m->cols+colpivot*C2+C1)) )
     {
       for(colp = (m->cols/C2)-1 ; colp > -1 ; colp--)
        {
         f = jfpivot_Z(m, rowpivot, colpivot, colp, rown_mns);

         (*(m->pb+rown_mns  *m->cols+colp*C2   )) = f.r;
         (*(m->pb+rown_mns  *m->cols+colp*C2+C1)) = f.i;
        }
     }
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :  On a row.                                                         */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void jcpivot_mZ(
PmZ  m,
int      rowpivot,
int      colpivot
)
{
int      rown_mns;

      for(rown_mns = rowpivot-1; rown_mns > -1 ; rown_mns--)
        {
          while( !(*(m->pb+rowpivot  *m->cols+colpivot*C2   ))
                             &&
                 !(*(m->pb+rowpivot  *m->cols+colpivot*C2+C1))
                             &&
                  (colpivot < (m->cols/C2)-1)
               )
               {
                colpivot++;
               }

         jrpivot_mZ(m, rowpivot, colpivot,rown_mns);
        }
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void jdpivot_mZ(
PmZ  m
)
{
int      rowpivot;

     for(rowpivot = (m->rows)-1; rowpivot  ; rowpivot--)
     {
      jcpivot_mZ(m, rowpivot,0);
     }
}


