/*         .h         freeware           http://groups.yahoo.com/group/mathc/ */

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_commuteh_mOZ(
PmZ sinA,
PmZ cosA,
int i
)
{
int        n;
complexZ det;

//MAT_TYPE pbA       [MXR][MXC];
//mZ A        ={MXR,MXC,&pbA       [0][0]};
//MAT_TYPE pbP       [MXR][MXC];
//mZ P        ={MXR,MXC,&pbP       [0][0]};
//MAT_TYPE pbInvP    [MXR][MXC];
//mZ InvP     ={MXR,MXC,&pbInvP    [0][0]};
//MAT_TYPE pbD       [MXR][MXC];
//mZ D        ={MXR,MXC,&pbD       [0][0]};
//MAT_TYPE pbsinD    [MXR][MXC];
//mZ sinD     ={MXR,MXC,&pbsinD    [0][0]};
//MAT_TYPE pbcosD    [MXR][MXC];
//mZ cosD     ={MXR,MXC,&pbcosD    [0][0]};
//MAT_TYPE pbT       [MXR][MXC];
//mZ T        ={MXR,MXC,&pbT       [0][0]};

mZ A;
mZ P;
mZ InvP;
mZ D;
mZ sinD;
mZ cosD;
mZ T;


                                 n = sinA->rows;

                     A.rows= n;                     A.cols= n*C2;
                     P.rows= n;                     P.cols= n*C2;
                  InvP.rows= n;                  InvP.cols= n*C2;
                     D.rows= n;                     D.cols= n*C2;
                  sinD.rows= n;                  sinD.cols= n*C2;
                  cosD.rows= n;                  cosD.cols= n*C2;
                     T.rows= n;                     T.cols= n*C2;


					 A.pB = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*A.rows*A.cols);
					 P.pB = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*P.rows*P.cols);
					 InvP.pB = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*InvP.rows*InvP.cols);
					 D.pB = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*D.rows*D.cols);
					 sinD.pB = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*sinD.rows*sinD.cols);
					 cosD.pB = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*cosD.rows*cosD.cols);
					 T.pB = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*T.rows*T.cols);
/*-------------------------------- PROGRAM ---------------------------------- */
  do
  {
               rnd_mZ(&P,i);
          det = det_Z(&P);
  }while( (!det.r) && (!det.i));

  rnd_diag_mZ(&D,i);
  inverse_mZ(&P,&InvP);
  mul_mZ(&P, &D,    &T);
  mul_mZ(&T, &InvP, &A);
  zeros_mZ(&cosD);
  zeros_mZ(&sinD);

  mul_mZ(&A,&P,&T);           /* invP A P = D : (eigenvalues on the diagonal) */
  mul_mZ(&InvP,&T,&D);
  diag_cosh_mOZ(&D,&cosD);    /*cosh(D) : (eigenvalues on the diagonal)       */
  mul_mZ(&P,&cosD,&T);
  mul_mZ(&T,&InvP,cosA);      /* P cosh(D) invP = cosh(A)                     */

  diag_sinh_mOZ(&D,&sinD);    /* sinh(D) : (eigenvalues on the diagonal)      */
  mul_mZ(&P,&sinD,&T);        /* P sinh(D) invP = sinh(A)                     */
  mul_mZ(&T,&InvP,sinA);

					 free(A.pB);
					 free(P.pB);
					 free(InvP.pB);
					 free(D.pB);
					 free(sinD.pB);
					 free(cosD.pB);
					 free(T.pB);
}


/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_commute_mOZ(
PmZ cosA,
PmZ sinA,
int i
)
{
int      n;
complexZ det;

//MAT_TYPE pbA       [MXR][MXC];
//mZ A        ={MXR,MXC,&pbA       [0][0]};
//MAT_TYPE pbP       [MXR][MXC];
//mZ P        ={MXR,MXC,&pbP       [0][0]};
//MAT_TYPE pbInvP    [MXR][MXC];
//mZ InvP     ={MXR,MXC,&pbInvP    [0][0]};
//MAT_TYPE pbD       [MXR][MXC];
//mZ D        ={MXR,MXC,&pbD       [0][0]};
//MAT_TYPE pbsinD    [MXR][MXC];
//mZ sinD     ={MXR,MXC,&pbsinD    [0][0]};
//MAT_TYPE pbcosD    [MXR][MXC];
//mZ cosD     ={MXR,MXC,&pbcosD    [0][0]};
//MAT_TYPE pbT       [MXR][MXC];
//mZ T        ={MXR,MXC,&pbT       [0][0]};


mZ A;
mZ P;
mZ InvP;
mZ D;
mZ sinD;
mZ cosD;
mZ T;

                                 n = sinA->rows;

                     A.rows= n;                     A.cols= n*C2;
                     P.rows= n;                     P.cols= n*C2;
                  InvP.rows= n;                  InvP.cols= n*C2;
                     D.rows= n;                     D.cols= n*C2;
                  sinD.rows= n;                  sinD.cols= n*C2;
                  cosD.rows= n;                  cosD.cols= n*C2;
                     T.rows= n;                     T.cols= n*C2;

					 A.pB = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*A.rows*A.cols);
					 P.pB = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*P.rows*P.cols);
					 InvP.pB = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*InvP.rows*InvP.cols);
					 D.pB = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*D.rows*D.cols);
					 sinD.pB = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*sinD.rows*sinD.cols);
					 cosD.pB = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*cosD.rows*cosD.cols);
					 T.pB = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*T.rows*T.cols);
/*-------------------------------- PROGRAM ---------------------------------- */
  do
  {
               rnd_mZ(&P,i);
          det = det_Z(&P);
  }while( (!det.r) && (!det.i));

  rnd_diag_mZ(&D,i);
  inverse_mZ(&P,&InvP);
  mul_mZ(&P, &D,    &T);
  mul_mZ(&T, &InvP, &A);
  zeros_mZ(&cosD);
  zeros_mZ(&sinD);

  mul_mZ(&A,&P,&T);          /* invP A P = D : (eigenvalues on the diagonal) */
  mul_mZ(&InvP,&T,&D);
  diag_cos_mOZ(&D,&cosD); /*   cos(D) : (eigenvalues on the diagonal)     */
  mul_mZ(&P,&cosD,&T);
  mul_mZ(&T,&InvP,cosA);    /*    P cos(D) invP = cos(A)                    */

  diag_sin_mOZ(&D,&sinD); /*   sin(D) : (eigenvalues on the diagonal)     */
  mul_mZ(&P,&sinD,&T);
  mul_mZ(&T,&InvP,sinA);    /*    P sin(D) invP = sin(A)                    */

					 free(A.pB);
					 free(P.pB);
					 free(InvP.pB);
					 free(D.pB);
					 free(sinD.pB);
					 free(cosD.pB);
					 free(T.pB);
}

