/*         .h         freeware           http://groups.yahoo.com/group/mathc/ */

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_Ltrig_mZ(
PmZ m,
int maxn)
{
int i;
int j;
MAT_TYPE s;

  for (   i = 0 ; i < m->rows ; i++)
    for ( j = 0 ; j < m->cols ; j+=C2)
       {

        *(m->pb+i *m->cols+j   ) = 0;
        *(m->pb+i *m->cols+j+C1) = 0;

       if( (i*C2) >= j)
          {
            s = rnd_I(maxn);   *(m->pb+i *m->cols+j   ) = s;
            s = rnd_I(maxn);   *(m->pb+i *m->cols+j+C1) = s;
         }
       }
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_Utrig_mZ(
PmZ m,
int maxn)
{
int i;
int j;
MAT_TYPE s;

  for (   i = 0 ; i < m->rows ; i++)
    for ( j = 0 ; j < m->cols ; j+=C2)
       {

        *(m->pb+i *m->cols+j   ) = 0;
        *(m->pb+i *m->cols+j+C1) = 0;

       if( (i*C2) <= j)
          {
            s = rnd_I(maxn);  *(m->pb+i *m->cols+j   ) = s;
            s = rnd_I(maxn);  *(m->pb+i *m->cols+j+C1) = s;
         }
       }
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_strictLtrig_mZ(
PmZ m,
int maxn)
{
int i;
int j;
MAT_TYPE s;

  for (   i = 0 ; i < m->rows ; i++)
    for ( j = 0 ; j < m->cols ; j+=C2)
       {

        *(m->pb+i *m->cols+j   ) = 0;
        *(m->pb+i *m->cols+j+C1) = 0;

       if( (i*C2) > j)
          {
            s = rnd_I(maxn);   *(m->pb+i *m->cols+j   ) = s;
            s = rnd_I(maxn);   *(m->pb+i *m->cols+j+C1) = s;
         }
       }
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_strictUtrig_mZ(
PmZ m,
int maxn)
{
int i;
int j;
MAT_TYPE s;

  for (   i = 0 ; i < m->rows ; i++)
    for ( j = 0 ; j < m->cols ; j+=C2)
       {

        *(m->pb+i *m->cols+j   ) = 0;
        *(m->pb+i *m->cols+j+C1) = 0;

       if( (i*C2) < j)
          {
            s = rnd_I(maxn);   *(m->pb+i *m->cols+j   ) = s;
            s = rnd_I(maxn);   *(m->pb+i *m->cols+j+C1) = s;
         }
       }
}


