/* .h                        free ware  http://groups.yahoo.com/group/mathc/  */

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_mr(
PmZ mA,
int     maxn)
{
MAT_TYPE s;
int      i;
int      j;

  for (   i = 0 ; i < mA->rows ; i++)
    for ( j = 0 ; j < mA->cols ; j += C2)
       {
        s = rnd_I(maxn);
        *(mA->pb+i *mA->cols+j   ) = s;
        *(mA->pb+i *mA->cols+j+C1) = 0;
       }
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd0_mr(
PmZ mA,
int     maxn)
{
MAT_TYPE s;
int    i;
int    j;

  for (   i = 0 ; i < mA->rows ; i++)
    for ( j = 0 ; j < mA->cols ; j += C2)
       {
        s = rnd0_I(maxn);
        *(mA->pb+i *mA->cols+j   ) = s;
        *(mA->pb+i *mA->cols+j+C1) = 0;
       }
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_diag_mr(
PmZ m,
int maxn)
{
int i;
int j;
MAT_TYPE s;

  for (   i = 0 ; i < m->rows ; i++)
    for ( j = 0 ; j < m->cols ; j+=C2)
       {

        *(m->pb+i *m->cols+j   ) = 0;
        *(m->pb+i *m->cols+j+C1) = 0;

       if( (i*C2) == j)
         {
            s = rnd_I(maxn);
          *(m->pb+i *m->cols+j  ) = s;
         }
       }
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rndp_diag_mr(
PmZ m,
int maxn)
{
int i;
int j;
MAT_TYPE s;

  for (   i = 0 ; i < m->rows ; i++)
    for ( j = 0 ; j < m->cols ; j+=C2)
       {

        *(m->pb+i *m->cols+j   ) = 0;
        *(m->pb+i *m->cols+j+C1) = 0;

       if( (i*C2) == j)
         {
            s = rndp_I(maxn);
          *(m->pb+i *m->cols+j  ) = s;
         }
       }
}


/* ------------------------------ FUNCTION ---------------------------------- */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_symetric_mr(
PmZ m,
int n)
{
int i;
int j;
MAT_TYPE Tnumer;

  if ((m->rows*C2)  != m->cols)
    {
     printf("\n rnd_symetric_mZ() ");
     printf("\n error - matrix must be square");
     printf("\n Press return to continue");
     getchar();
     exit(1);
    }

  for (   i = 0 ; i <  m->rows ;   i++)
    for ( j = 0 ; j < (m->cols); j+=C2)
       {
        Tnumer = rnd_I (n);

        *(m->pb+i      *m->cols+j)        = Tnumer;
        *(m->pb+i      *m->cols+j+1)      = 0;
        *(m->pb+(j/C2) *m->cols+i*C2)     = Tnumer;
        *(m->pb+(j/C2) *m->cols+(i*C2)+1) = 0;
        }

}

