/* .h                        free ware  http://groups.yahoo.com/group/mathc/  */
/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_ortho_uv_Z(
PmZ mu,
PmZ mv,
    int n)
{
     int i;
     int j;
complexZ InnerProduct;

   rnd_mZ(mu,n);
   rnd_mZ(mv,n);

       i = mu->rows - 1;
       j = mu->cols - C2;

     *(mu->pb+i *mu->cols+j   ) = 0;
     *(mu->pb+i *mu->cols+j+C1) = 0;

     *(mv->pb+i *mv->cols+j   ) = 1;
     *(mv->pb+i *mv->cols+j+C1) = 0;

     InnerProduct = innerprod_Z(mu,mv);

     *(mu->pb+i *mu->cols+j   ) = -InnerProduct.r;
     *(mu->pb+i *mu->cols+j+C1) = -InnerProduct.i;
}


/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_orth_mr(
PmZ mA,
int max
)
{
     int        n;
complexZ       z;
complexZ       Norm;
complexZ    InvNorm;
MAT_TYPE      Two = 2;


MAT_TYPE pbID    [MXR][MXC];mZ mID     ={MXR,MXC,&pbID    [0][0]};
MAT_TYPE pbx     [MXR][MXC];mZ mx      ={MXR,MXC,&pbx     [0][0]};
MAT_TYPE pTrpsx  [MXR][MXC];mZ mTrpsx  ={MXR,MXC,&pTrpsx  [0][0]};
MAT_TYPE px_Trpsx[MXR][MXC];mZ mx_Trpsx={MXR,MXC,&px_Trpsx[0][0]};

MAT_TYPE pInvNorm_mx_Trpsx [MXR][MXC];
mZ mInvNorm_mx_Trpsx={MXR, MXC,&pInvNorm_mx_Trpsx[0][0]};

                                   n = mA->rows;
                    mID.rows= n;                    mID.cols= n*C2;
                     mx.rows= n;                   mx.cols=   1*C2;
                 mTrpsx.rows= 1;                 mTrpsx.cols= n*C2;
               mx_Trpsx.rows= n;               mx_Trpsx.cols= n*C2;
      mInvNorm_mx_Trpsx.rows= n;      mInvNorm_mx_Trpsx.cols= n*C2;
/*-------------------------------- PROGRAM ---------------------------------- */
  rnd_mr(&mx,max);
    eye_mZ(&mID);

     Norm = normP2_Z(&mx);

  if(!Norm.r)
    {
     printf("\n rnd_orth_mr() error - 1/0");
     printf("\n Press return to continue");
     getchar();
     exit(1);
    }
                         z = inv_Z(Norm);
  InvNorm = smul_Z(Two,z);

   transpose_mZ(&mx,&mTrpsx);
       mul_mZ(&mx,&mTrpsx,&mx_Trpsx);

  smul_mZ(InvNorm.r,&mx_Trpsx,&mInvNorm_mx_Trpsx);
    sub_mZ(&mID,             &mInvNorm_mx_Trpsx, mA);
}
