/* .h                        free ware  http://groups.yahoo.com/group/mathc/  */

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* see   :                                                                    */
/* -------------------------------------------------------------------------- */
void projwn_mZ(
PmZ mu,
PmZ mv,
PmZ mvn
)
{
complexZ InnerProduv;
complexZ     NormvP2;
complexZ   InvNormP2;
complexZ InnerProduv_InvNormP2;
/*-------------------------------- PROGRAM ---------------------------------- */
             InnerProduv = innerprod_Z(mu,mv);
                 NormvP2 =    normP2_Z(   mv);
               InvNormP2 =       inv_Z(NormvP2);

   InnerProduv_InvNormP2 =  mul_Z(InnerProduv,InvNormP2);

        zmul_mZ(InnerProduv_InvNormP2,mv,mvn);
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void projwn_r_mZ(
PmZ mU,
int r_U,
PmZ mV,
int r_V,
PmZ mVn,
int r_Vn
)
{
complexZ InnerProduv;
complexZ     NormvP2;
complexZ   InvNormP2;
complexZ InnerProduv_InvNormP2;

MAT_TYPE pu [MXR][MXC];mZ u ={MXR,MXC,&pu [0][0]};
MAT_TYPE pv [MXR][MXC];mZ v ={MXR,MXC,&pv [0][0]};
MAT_TYPE pvn[MXR][MXC];mZ vn={MXR,MXC,&pvn[0][0]};

             u.rows = 1;       u.cols = mU->cols;
             v.rows = 1;       v.cols = mU->cols;
            vn.rows = 1;      vn.cols = mU->cols;
/*-------------------------------- PROGRAM ---------------------------------- */

             copy_r_Z(mU,r_U,&u,0);
             copy_r_Z(mV,r_V,&v,0);

             InnerProduv = innerprod_Z(&u,&v);
                 NormvP2 =    normP2_Z(   &v);

  if(NormvP2.r || NormvP2.i) InvNormP2 =  inv_Z(NormvP2);
  InnerProduv_InvNormP2 =  mul_Z(InnerProduv,InvNormP2);

         zmul_mZ(InnerProduv_InvNormP2,&v,&vn);

               copy_r_Z(&vn,0,mVn,r_Vn);
}


