/* .h                        free ware  http://groups.yahoo.com/group/mathc/  */

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ innerprod_Mnm_Z(
PmZ mU,
PmZ mV
)
{
complexZ InnerProduct;

MAT_TYPE pbTrpsU [MXR][MXC*C2];mZ mTrpsU ={MXR,MXC*C2,&pbTrpsU [0][0]};
MAT_TYPE pbcnjV  [MXR][MXC*C2];mZ mcnjV  ={MXR,MXC*C2,&pbcnjV  [0][0]};

MAT_TYPE pbTrpsU_cnjV[MXR][MXC*C2];mZ mTrpsU_cnjV ={MXR,MXC*C2,&pbTrpsU_cnjV[0][0]};

               mcnjV.rows = mV->rows;             mcnjV.cols = mV->cols;
              mTrpsU.rows = mU->cols/C2;         mTrpsU.cols = mU->rows*C2;
         mTrpsU_cnjV.rows = mTrpsU.rows;    mTrpsU_cnjV.cols = mV->cols;

                  c_mZ(mV,&mcnjV);
            transpose_mZ(mU,&mTrpsU);
                  mul_mZ(&mTrpsU,&mcnjV,&mTrpsU_cnjV);
  InnerProduct= trace_mZ(&mTrpsU_cnjV);

 return(InnerProduct);
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ normP2_Mnm_Z(
PmZ mu
)
{
complexZ NormP2;

         NormP2 = innerprod_Mnm_Z(mu,mu);

  return(NormP2);
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ distanceP2_Mnm_Z(
PmZ mu,
PmZ mv
)
{
complexZ DistanceP2;

MAT_TYPE pbu_mns_v [MXR][MXC*C2];mZ mu_mns_v={MXR, MXC*C2,&pbu_mns_v[0][0]};

       mu_mns_v.rows = mu->rows;
       mu_mns_v.cols = mu->cols;

      sub_mZ(mu,mv,&mu_mns_v);

  DistanceP2 = normP2_Mnm_Z(&mu_mns_v);

  return(DistanceP2);
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void projwn_Mnm_mZ(
PmZ mu,
PmZ mv,
PmZ mvn
)
{
complexZ InnerProduv;
complexZ               NormvP2;
complexZ             InvNormvP2;
complexZ InnerProduv_InvNormvP2;
/*-------------------------------- PROGRAM ---------------------------------- */
             InnerProduv = innerprod_Mnm_Z(mu,mv);
                 NormvP2 =    normP2_Mnm_Z(mv);
               InvNormvP2 =          inv_Z(NormvP2);
   InnerProduv_InvNormvP2 =          mul_Z(InnerProduv,InvNormvP2);
                                   zmul_mZ(InnerProduv_InvNormvP2,mv,mvn);
}

