/* .h                        free ware  http://groups.yahoo.com/group/mathc/  */

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ pivotnt0_mZ(
PmZ mA,
 int r1)
{
complexZ sign;
   int rT;
MAT_TYPE pivot_r;
MAT_TYPE pivot_i;
MAT_TYPE t_r;
MAT_TYPE t_i;


  sign = init_Z(1,0);
  pivot_r = *(mA->pb+r1 *mA->cols+ r1*C2    );
  pivot_i = *(mA->pb+r1 *mA->cols+(r1*C2)+C1);


  if(!pivot_r && !pivot_i && ((r1+1)<mA->rows) )
  {
   rT = r1+1;

   do
   {
    t_r = *(mA->pb+rT *mA->cols+ r1*C2    );
    t_i = *(mA->pb+rT *mA->cols+(r1*C2)+C1);

    if(t_r || t_i)
      {
       swap_r_Z(mA,r1,rT);
       rT = mA->rows;
       sign = init_Z(-1,0);
      }

    rT++;
   }
   while(rT < mA->rows);

  }

return(sign);
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ pivotwork_mZ(
PmZ mA,
int      row1,
int      row2,
complexZ z_deter)
{
int      j;
complexZ z_pivot;
complexZ z_under;
complexZ z_p;
complexZ z_u;
complexZ z;

    z_pivot.r =  (*(mA->pb+row1 *mA->cols+row1*C2   ));
    z_pivot.i =  (*(mA->pb+row1 *mA->cols+row1*C2+C1));

    z_under.r = -(*(mA->pb+row2 *mA->cols+row1*C2   ));
    z_under.i = -(*(mA->pb+row2 *mA->cols+row1*C2+C1));

 if(z_under.r || z_under.i)
 {

  z_deter = mul_Z(z_deter,inv_Z(z_pivot));
     /* printf("Pivot"); p_Z(z_pivot); getchar();    */

  for( j=0 ; (j*C2)<mA->cols; j++)
     {
      z_p.r =  (*(mA->pb+row1 *mA->cols+j*C2   ));
      z_p.i =  (*(mA->pb+row1 *mA->cols+j*C2+C1));

      z_u.r =  (*(mA->pb+row2 *mA->cols+j*C2   ));
      z_u.i =  (*(mA->pb+row2 *mA->cols+j*C2+C1));

      z = add_Z(mul_Z(z_u,z_pivot),
                 mul_Z(z_p,z_under));

                 (*(mA->pb+row2 *mA->cols+j*C2   )) = z.r;
                 (*(mA->pb+row2 *mA->cols+j*C2+C1)) = z.i;
     }
 }
 return(z_deter);
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    : All pivot = 1.                                                     */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void pivot1_mZ(
PmZ  m
)
{
     int i;
     int j;
complexZ f;

 for ( i=0 ; i<m->rows ; i++)
   for ( j=0 ; j<m->cols; j+=C2)
     if( (*(m->pb+i *m->cols+j))
                  ||
         (*(m->pb+i *m->cols+j+C1))
       )
       {
        f.r = *(m->pb+i *m->cols+j   );
        f.i = *(m->pb+i *m->cols+j+C1);

         f = inv_Z(f);

          mul_r_Z(m,i,f);

         j = m->cols;
       }
}

