
#ifndef CONFIG_H
#define CONFIG_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>



struct configure_s
{
	int K;
	int noOfTuple;
	int noOfDim;
	char *dataFilename;
	char *dimFilename;
	char *hierarchyFilename;
	char *genDataFilename;
	char *sensitiveSetFilename;

	double alpha;

	int noOfSenAttr;
	int *senAttrNo;
	int senStartNo;
	int senEndNo;

	int d;

	double s;
	int noOfCondition;
	int queryNoOfDim;

	float error;
	float sigma;

	double minConf;
	double minExp;
	double tThreshold;

	int alg;
};

typedef struct configure_s configure;

configure *readConfig(char *filename);

#endif
