/*         .h         freeware           http://groups.yahoo.com/group/mathc/ */

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
MAT_TYPE cofactor_R(
PmR mA,
int ci,
int cj)
{
MAT_TYPE f;

          f   = minor_R(mA,ci,cj);
          f *=  (MAT_TYPE) pow(-1,(ci+1+cj+1));

  return(f);
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void    cofactor_mR(
PmR mA,
PmR mCofactor)
{
     int i;
     int j;

  if (mA->rows != mCofactor->rows || mA-> cols != mCofactor->cols)
    {
     printf("\n mcofactor() error - matrices different sizes");
     printf("\n Press return to continue");
     //getchar();
     //exit(1);
    }

 for  (i=0 ; i<mA->rows ; i++)
   for(j=0 ; j<mA->cols ; j++)
     *(mCofactor->pb+i *mCofactor->cols+j)=cofactor_R(mA,i, j);
}


