/*         .h         freeware           http://groups.yahoo.com/group/mathc/ */


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void projwn_mR(
PmR mu,
PmR mv,
PmR mvn
)
{
MAT_TYPE InnerProduv;
MAT_TYPE     NormvP2;
MAT_TYPE   InvNormP2;
MAT_TYPE InnerProduv_InvNormP2;
/*-------------------------------- PROGRAM ---------------------------------- */
             InnerProduv = innerprod_R(mu,mv);
                 NormvP2 =    normP2_R(   mv);
  if(!NormvP2)
    {
     printf("\n projwn_mR() error - 1/0");
     printf("\n Press return to continue");
     //getchar();
     //exit(1);
    }
               InvNormP2 =   (MAT_TYPE)     (1./NormvP2);

   InnerProduv_InvNormP2 =  InnerProduv*InvNormP2;

        smul_mR(InnerProduv_InvNormP2,mv,mvn);
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void projwn_r_mR(
PmR mU,
int r_U,
PmR mV,
int r_V,
PmR mVn,
int r_Vn
)
{
MAT_TYPE InnerProduv;
MAT_TYPE     NormvP2;
MAT_TYPE   InvNormP2;
MAT_TYPE InnerProduv_InvNormP2;

//MAT_TYPE pu [MXR][MXC];
//mR u ={MXR,MXC,&pu [0][0]};
//MAT_TYPE pv [MXR][MXC];
//mR v ={MXR,MXC,&pv [0][0]};
//MAT_TYPE pvn[MXR][MXC];
//mR vn={MXR,MXC,&pvn[0][0]};
mR u;
mR v;
mR vn;

             u.rows = 1;       u.cols = mU->cols;
             v.rows = 1;       v.cols = mU->cols;
            vn.rows = 1;      vn.cols = mU->cols;

			u.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*u.rows*u.cols);
			v.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*v.rows*v.cols);
			vn.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*vn.rows*vn.cols);

             copy_r_R(mU,r_U,&u,0);
             copy_r_R(mV,r_V,&v,0);

             InnerProduv = innerprod_R(&u,&v);
                 NormvP2 =    normP2_R(   &v);
  if(NormvP2) InvNormP2 =   (MAT_TYPE) (1./NormvP2);
  else InvNormP2 = 0;

   InnerProduv_InvNormP2 =  InnerProduv*InvNormP2;

        smul_mR(InnerProduv_InvNormP2,&v,&vn);

               copy_r_R(&vn,0,mVn,r_Vn);

			   free(u.pb);
			   free(v.pb);
			   free(vn.pb);
}


