/*         .h         freeware           http://groups.yahoo.com/group/mathc/ */

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    : On a MAT_TYPE.                                                     */
/*                                                                            */
/* -------------------------------------------------------------------------- */
MAT_TYPE jfpivotR(
PmR  m,
int      rowpivot,
int      colpivot,
int      colp,
int      rown_mns
)
{
MAT_TYPE f;

MAT_TYPE fn;
MAT_TYPE fn_mns;

MAT_TYPE fp;
MAT_TYPE fpivot;

  fpivot =  (*(m->pb+rowpivot  *m->cols+colpivot));
      fp =  (*(m->pb+rowpivot  *m->cols+colp    ));
  fn_mns = -(*(m->pb+rown_mns *m->cols+colpivot ));
      fn =  (*(m->pb+rown_mns  *m->cols+colp    ));


if(colpivot!=colp)  f = (fpivot*fn) + (fp*fn_mns);

if(colpivot==colp)
{
 (*(m->pb+rown_mns *m->cols+colpivot)) = 0;
 f = (fpivot*fn) + (fp*fn_mns);
}

 return(f);
}


/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :  On a row.                                                         */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void jrpivotR(
PmR  m,
int      rowpivot,
int      colpivot,
int      rown_mns
)
{
     int colp;
MAT_TYPE f;

    if((*(m->pb+rowpivot  *m->cols+colpivot)))
       for(colp=(m->cols)-1; colp>-1; colp--)
        {
         f = jfpivotR(m, rowpivot, colpivot, colp, rown_mns);
         (*(m->pb+rown_mns  *m->cols+colp)) = f;
        }
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :  On a row.                                                         */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void jcpivotR(
PmR  m,
int      rowpivot,
int      colpivot
)
{
int      rown_mns;

      for(rown_mns=rowpivot-1; rown_mns>-1; rown_mns--)
        {
          while( !(*(m->pb+rowpivot  *m->cols+colpivot)) &&
                  (colpivot < (m->cols)-1)) colpivot++;
         jrpivotR(m, rowpivot, colpivot,rown_mns);
        }
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void jdpivotR(
PmR  m
)
{
int      rowpivot;

     for(rowpivot = (m->rows)-1; rowpivot  ; rowpivot--)
         jcpivotR(m, rowpivot,0);
}


