/*         .h         freeware           http://groups.yahoo.com/group/mathc/ */

/* --------------------------------- FUNCTRON ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_Ltrig_mR(
PmR m,
int n)
{
int i;
int j;

  if (m->rows  != m->cols)
    {
     printf("\n rnd_Ltrig_mR() error - matrix must be square");
     printf("\n Press return to continue");
     //getchar();
     //exit(1);
    }

  for (   i = 0 ; i < m->rows ; i++)
    for ( j = 0 ; j < m->cols ; j++)
       {
        *(m->pb+i *m->cols+j  ) = 0;
        if( (i) >= j) *(m->pb+i *m->cols+j) =  (MAT_TYPE) rnd_I(n);
       }
}



/* --------------------------------- FUNCTRON ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_Utrig_mR(
PmR m,
int n)
{
int i;
int j;

  if (m->rows  != m->cols)
    {
     printf("\n rnd_Utrig_mR() error - matrix must be square");
     printf("\n Press return to continue");
     //getchar();
     //exit(1);
    }

  for (   i = 0 ; i < m->rows ; i++)
    for ( j = 0 ; j < m->cols ; j++)
       {
        *(m->pb+i *m->cols+j  ) = 0;
        if( (i) <= j)   *(m->pb+i *m->cols+j) =  (MAT_TYPE) rnd_I(n);
       }
}


/* --------------------------------- FUNCTRON ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_strictLtrig_mR(
PmR m,
int n)
{
int i;
int j;

  if (m->rows  != m->cols)
    {
     printf("\n rnd_Ltrig_mR() error - matrix must be square");
     printf("\n Press return to continue");
     //getchar();
     //exit(1);
    }

  for (   i = 0 ; i < m->rows ; i++)
    for ( j = 0 ; j < m->cols ; j++)
       {
        *(m->pb+i *m->cols+j  ) = 0;
        if( (i) > j) *(m->pb+i *m->cols+j) =  (MAT_TYPE) rnd_I(n);
       }
}



/* --------------------------------- FUNCTRON ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_strictUtrig_mR(
PmR m,
int n)
{
int i;
int j;

  if (m->rows  != m->cols)
    {
     printf("\n rnd_Utrig_mR() error - matrix must be square");
     printf("\n Press return to continue");
     //getchar();
     //exit(1);
    }

  for (   i = 0 ; i < m->rows ; i++)
    for ( j = 0 ; j < m->cols ; j++)
       {
        *(m->pb+i *m->cols+j  ) = 0;
        if( (i) < j)   *(m->pb+i *m->cols+j) =  (MAT_TYPE) rnd_I(n);
       }
}

