/* .h                        free ware  http://groups.yahoo.com/group/mathc/  */

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void LU_mZ(
PmZ m,
PmZ mL,
PmZ mU
)
{
complexZ pivot;
complexZ underpivot;
     int rowpivot;
     int rowunder;
     int col;

     zeros_mZ(  mL);
   copy_mZ(m,mU);


for( rowpivot=0, col=0; rowpivot<(mU->rows); rowpivot++, col+=C2)
{
  pivot.r = *(mU->pb+rowpivot *mU->cols+col   );
  pivot.i = *(mU->pb+rowpivot *mU->cols+col+C1);

  pivot = inv_Z(pivot);

  *(mL->pb+rowpivot *mL->cols+col   )=*(mU->pb+rowpivot *mU->cols+col   );
  *(mL->pb+rowpivot *mL->cols+col+C1)=*(mU->pb+rowpivot *mU->cols+col+C1);

    mul_r_Z(mU,rowpivot,pivot);

  for(rowunder = rowpivot+1; rowunder<mU->rows; rowunder++ )
     {
      *(mL->pb+rowunder *mL->cols+col   )=  *(mU->pb+rowunder *mU->cols+col   );
      *(mL->pb+rowunder *mL->cols+col+C1)=  *(mU->pb+rowunder *mU->cols+col+C1);

                         underpivot.r = -(*(mU->pb+rowunder *mU->cols+col   ));
                         underpivot.i = -(*(mU->pb+rowunder *mU->cols+col+C1));

        add_r_Z(mU,underpivot,rowpivot,rowunder);
     }
}
}



/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void PLU_mZ(
PmZ m,
PmZ mP,
PmZ mL,
PmZ mU
)
{
complexZ pivot;
complexZ underpivot;
  MAT_TYPE PIVOT_R_ZERO;
  MAT_TYPE PIVOT_I_ZERO;
  MAT_TYPE PIVOT_R_UNDER;
  MAT_TYPE PIVOT_I_UNDER;
     int ROW_T;
     int rowpivot;
     int rowunder;
     int col;

MAT_TYPE pT [MXR][MXC*C2]; mZ mT ={MXR,MXC*C2,&pT[0][0]};

             mT.rows = mU->rows;       mT.cols = mU->cols;

       eye_mZ(  mP);
     zeros_mZ(  mL);
      copy_mZ(m,mU);


for( rowpivot=0, col=0; rowpivot<(mU->rows); rowpivot++, col+=C2)
{

 PIVOT_R_ZERO=*(mU->pb+rowpivot *mU->cols+col   );
 PIVOT_I_ZERO=*(mU->pb+rowpivot *mU->cols+col+C1);

  if( ((!PIVOT_R_ZERO) && (!PIVOT_I_ZERO)) )
    {
     ROW_T=rowpivot+1;
     while((ROW_T<(mU->rows)))
          {
           PIVOT_R_UNDER = *(mU->pb+ROW_T *mU->cols+col   );
           PIVOT_I_UNDER = *(mU->pb+ROW_T *mU->cols+col+C1);
           if( ((PIVOT_R_UNDER) || (PIVOT_I_UNDER)) )
             {
              swap_r_Z(mU,rowpivot,ROW_T);
              swap_r_Z(mP,rowpivot,ROW_T);
              ROW_T= (mU->rows)+10;
             }
           ROW_T++;
          }
    }

  pivot.r = *(mU->pb+rowpivot *mU->cols+col   );
  pivot.i = *(mU->pb+rowpivot *mU->cols+col+C1);

  pivot = inv_Z(pivot);

  *(mL->pb+rowpivot *mL->cols+col   )=*(mU->pb+rowpivot *mU->cols+col   );
  *(mL->pb+rowpivot *mL->cols+col+C1)=*(mU->pb+rowpivot *mU->cols+col+C1);

    mul_r_Z(mU,rowpivot,pivot);

  for(rowunder = rowpivot+1; rowunder<mU->rows; rowunder++ )
     {
      *(mL->pb+rowunder *mL->cols+col   )=  *(mU->pb+rowunder *mU->cols+col   );
      *(mL->pb+rowunder *mL->cols+col+C1)=  *(mU->pb+rowunder *mU->cols+col+C1);

                         underpivot.r = -(*(mU->pb+rowunder *mU->cols+col   ));
                         underpivot.i = -(*(mU->pb+rowunder *mU->cols+col+C1));

        add_r_Z(mU,underpivot,rowpivot,rowunder);
     }
}
     mul_mZ( mP,m, &mT);
      LU_mZ(&mT,mL, mU);
}

