/* .h                        free ware  http://groups.yahoo.com/group/mathc/  */

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_mZ(
PmZ mA,
int     maxn)
{
MAT_TYPE s;
int      i;
int      j;

  for (   i = 0 ; i < mA->rows ; i++)
    for ( j = 0 ; j < mA->cols ; j += C2)
       {
        s = rnd_I(maxn);
        *(mA->pb+i *mA->cols+j  ) = s;

        s = rnd_I(maxn);
        *(mA->pb+i *mA->cols+j+C1) = s;
       }
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd0_mZ(
PmZ mA,
int     maxn)
{
MAT_TYPE s;
int    i;
int    j;

  for (   i = 0 ; i < mA->rows ; i++)
    for ( j = 0 ; j < mA->cols ; j += C2)
       {
        s = rnd0_I(maxn);
        *(mA->pb+i *mA->cols+j  ) = s;

        s = rnd0_I(maxn);
        *(mA->pb+i *mA->cols+j+C1) = s;
       }
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_diag_mZ(
PmZ m,
int maxn)
{
int i;
int j;
MAT_TYPE s;

  for (   i = 0 ; i < m->rows ; i++)
    for ( j = 0 ; j < m->cols ; j+=C2)
       {

        *(m->pb+i *m->cols+j   ) = 0;
        *(m->pb+i *m->cols+j+C1) = 0;

       if( (i*C2) == j)
         {
            s = rnd_I(maxn);
          *(m->pb+i *m->cols+j   ) = s;
            s = rnd_I(maxn);
          *(m->pb+i *m->cols+j+C1) = s;
         }
       }
}

/* ------------------------------ FUNCTION ---------------------------------- */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void rnd_hermitian_mZ(
PmZ m,
int n)
{
int i;
int j;
MAT_TYPE real;
MAT_TYPE imag;

  if ((m->rows*C2)  != m->cols)
    {
     printf("\n rnd_hermitian_mZ() ");
     printf("\n error - matrix must be square");
     printf("\n Press return to continue");
     getchar();
     exit(1);
    }

  for (   i = 0 ; i <  m->rows ;   i++)
    for ( j = 0 ; j < (m->cols); j+=C2)
       {
        real = rnd_I (n);
        imag = rnd_I (n);

        *(m->pb+i      *m->cols+j)        =  real;
        *(m->pb+i      *m->cols+j+1)      =  imag;
        *(m->pb+(j/C2) *m->cols+i*C2)     =  real;
        *(m->pb+(j/C2) *m->cols+(i*C2)+1) = -imag;

         if((i*C2) == j) *(m->pb+i *m->cols+j+1) =  0;
        }

}

