
#ifndef MECHDIST_H
#define MECHDIST_H

#include "mech.h"

struct dimensionSet_s
{
	int noOfElt;
	dimension **elt;
};

typedef struct dimensionSet_s dimensionSet;

struct dimensionSetSet_s
{
	int noOfElt;
	dimensionSet **elt;
};

typedef struct dimensionSetSet_s dimensionSetSet;


void calculateQIDInfoLossAndSenDistortion(int noOfQID, int totalNoOfTuple, equivalenceClass *eqClass, generalizedAllTable *genAllTable, double *infoLoss, double *distortion, int *noOfSenChange);

dimensionSetSet *readSensitiveSet(configure *conf);
void createSenValueInEqClass(equivalenceClass *eqClass, data *dataSet, int noOfValueInSenAttr);
equivalenceClass *mechDistortionMain(data *dataSet, configure *conf, generalizedAllTable *genAllTable);
void copySenValueToNewSenValueInEqClass(equivalenceClass *eqClass, int noOfValueInSenAttr);

#endif
